#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2three4search.py">
#<abstract4xi abstract = "shoots to direction three"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2three4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2three4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2three4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4three

global count2ack4three
global count2nack4three
global count2found4three
global count2short4three

global current2series4three
global candidate2series4three

global fileobject4three  

global keys2profile4three
global key2profile4three

global left2find4three

global maxsize2ack4three    
global maxsize2file4three 
global max2short4three
global meansize2ack4three
global minsize2ack4three

global three2analyse4search

global profile2fetch4three

global right2find4three

global sumsize2ack4three    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4three = VersionKB4Xi['base2shoot4three']             # base internet address, None=local url

count2ack4three   = 0
count2nack4three  = 0
count2found4three = 0
count2short4three = 0

left2find4three = '('

max2short4three = VersionKB4Xi['max2short4three']
maxsize2file4three = VersionKB4Xi['maxsize2file4three']
maxsize2ack4three  = 0
meansize2ack4three = 0
minsize2ack4three  = 0

current2series4three = "current2series4three5dummy"
candidate2series4three  = "candidate2series4three5dummy"


three2analyse4search  = VersionKB4Xi['three2analyse4search']

profile2fetch4three = {}
profile2fetch4three [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4three [2] = '.jpg'
keys2profile4three = profile2fetch4three.keys()

right2find4three = ')'

sumsize2ack4three  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4three" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4three(target2explore4three):
    global count2ack4three
    global count2nack4three
    global count2found4three
    global count2short4three
    
    global fileobject4three 
       
    global keys2profile4three
    global key2profile4three
    
    global left2find4three

    global max2short4three    
    global maxsize2file4three     
    global maxsize2ack4three    
    global meansize2ack4three
    global minsize2ack4three
  
    global candidate2series4three
    global current2series4three
    
    
    global profile2fetch4three                         # extension for files
    
    global right2find4three
    
    global sumsize2ack4three    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4three = count2found4three + 1
    ack2debug4three = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4three)
    
    ack2profile = False
    for key2profile4three in keys2profile4three:
        if name2target[1] == profile2fetch4three[key2profile4three]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2THREE4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4three
        if ack2debug4three is True:
            print("(STEP 0A/33) OF SHOOT2THREE4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2THREE4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4three:
            count2nack4three = count2nack4three + 1
        else:
            count2ack4three = count2ack4three + 1
            sumsize2ack4three = sumsize2ack4three + size2file
            if size2file > maxsize2ack4three:
                maxsize2ack4three = size2file
            if ((size2file < minsize2ack4three) or (minsize2ack4three == 0)):
                print("(STEP 0B/33) OF SHOOT2THREE4SEARCH - USING MINSIZE2ACK4THREE: ", minsize2ack4three, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4THREE:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2three//d\threefly29july2012\threefly29july2012 (1).JPG 
                # USING MINSIZE2ACK4THREE:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2three//d\threefly29july2012\threefly29july2012 (2).JPG
                minsize2ack4three = size2file
                print("(STEP 0C/33) OF SHOOT2THREE4SEARCH - SET MINSIZE2ACK4THREE TO: ", minsize2ack4three, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4THREE TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2three//d\threefly29july2012\threefly29july2012 (1).JPG
                # SET MINSIZE2ACK4THREE TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2three//d\threefly29july2012\threefly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4three = target2explore4three
            if ack2debug4three is True:print("(STEP 1A/33) OF SHOOT2THREE4SEARCH - URL2WEB4THREE: ", url2web4three) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4three,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4three = url2web4three[0:index2edit] + string2use + url2web4three[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4three)
            shortname2web4three = name2web[0]
            if ack2debug4three is True:
                print("(STEP 1B/33) OF SHOOT2THREE4SEARCH - SHORTNAME2WEB4THREE: ", shortname2web4three)
                # 
            
            string2find4three = '/'
            ackall2found4three = False           
            while 1:
                if ackall2found4three is True:
                    break
                else:
                    index2find4three=str.find(shortname2web4three,string2find4three)   
                    if index2find4three == -1:
                        ackall2found4three = True
                    else:
                        shortname2web4three = shortname2web4three[index2find4three+1:]
                        
            if ack2debug4three is True:            
                print("(STEP 1C/33) OF SHOOT2THREE4SEARCH - SHORTNAME2WEB4THREE: ", shortname2web4three)
                # 
                
            ackall2found4three = False 
            while 1:
                if ackall2found4three is True:
                    break
                else:
                    index2left4three=str.find(shortname2web4three,left2find4three)
                    if index2left4three == -1:
                        current2series4three = shortname2web4three
                        if ack2debug4three is True:
                            print("(STEP 2A/33) OF SHOOT2THREE4SEARCH - CURRENT2SERIES4THREE: ", current2series4three) 
                            # 
                        ackall2found4three = True
                         
                    else:
                        index2right4three=str.find(shortname2web4three,right2find4three)
                        if index2right4three == -1:
                            ackall2found4three = True 
                        else:
                            candidate2series4three = shortname2web4three[0:index2left4three]
                            
                            index3find4three=str.find(shortname2web4three,current2series4three)
                            if index3find4three == -1:
                                
                                current2series4three = candidate2series4three
                                if ack2debug4three is True:
                                    print("(STEP 2B/33) OF SHOOT2THREE4SEARCH - CURRENT2SERIES4THREE: ", current2series4three) 
                                    # 
                                
                                count2short4three = 0
                                fileobject4three.write('<br />' + '\n')
                            else:
                                shortname2web4three = shortname2web4three[index2left4three:index2right4three+1]
                                if ack2debug4three is True:
                                    print("(STEP 2C/33) OF SHOOT2THREE4SEARCH - SHORTNAME2WEB4THREE: ", shortname2web4three)
                                    # 
                                
                                count2short4three = count2short4three + 1
                                if count2short4three >= max2short4three:
                                    count2short4three = 0
                                else:
                                    pass       
                            ackall2found4three = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4three is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4three.write('<br /><b>&raquo;</b><a href="' + url2web4three + '" target="_blank">' + shortname2web4three + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4three = three2analyse4search
                if ack2debug4three is True:
                    print("(STEP 3A/33) OF SHOOT2THREE4SEARCH - BASE2LOCAL4THREE: ", base2local4three)
                    #              
                ack2localtries4three = False                   
                while 1:
                    if ack2localtries4three is True:
                        break
                    else:
                        index2find4three=str.find(url2web4three,base2local4three)            
                        # 
                        #  
                        if index2find4three == -1:
                            ack2localtries4three = True
                        else:
                            if ack2debug4three is True:
                                print("(STEP 3B/33) OF SHOOT2THREE4SEARCH - BASE2BUILD4THREE: ", base2build4three)
                                # 
                            url2web4three = base2build4three + url2web4three[len(base2local4three):]
                            if ack2debug4three is True:
                                print("(STEP 3C/33) OF SHOOT2THREE4SEARCH - URL2WEB4THREE: ", url2web4three)
                                # 
                            
                            if count2short4three < 1: 
                                fileobject4three.write('<br /><b>&raquo;</b><a href="' + url2web4three + '" target="_blank">' + shortname2web4three + '</a>' + '\n')
                            else:
                                fileobject4three.write('<b>&raquo;</b><a href="' + url2web4three + '" target="_blank">' + shortname2web4three + '</a>\n')                            
                            ack2localtries4three = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2THREE4SEARCH FAILED, FILEOBJECT4THREE-WRITE-FAILED: ", str(fileobject4three), time4xi())
      
    else:
        
        count2nack4three = count2nack4three + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2three4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2three4search(queue2three = None, consumer_channel2three = None, publisher_channel2three = None, path2three = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4three
    global count2nack4three
    global count2found4three
    
    global fileobject4three    
    
    global maxsize2ack4three    
    global meansize2ack4three
    global minsize2ack4three
    global sumsize2ack4three    
    
    global maxsize2file4three 
    
    global profile2fetch4three                         # extension for files
    global keys2profile4three
    global key2profile4three

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2THREE4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2THREE4SEARCH -  QUEUE2THREE: ", queue2three)      
    # QUEUE2THREE:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2THREE4SEARCH -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
    # CONSUMER_CHANNEL2THREE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2THREE4SEARCH -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
    # PUBLISHER_CHANNEL2THREE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2three is None) or (consumer_channel2three is None) or (publisher_channel2three is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2THREE4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2THREE4SEARCH - QUEUE2THREE: ", queue2three)
        print("(STEP 1C/33) OF SHOOT2THREE4SEARCH - CONSUMER_CHANNEL2THREE: ", consumer_channel2three) 
        print("(STEP 1D/33) OF SHOOT2THREE4SEARCH - PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)
        print("(STEP 1E/33) OF SHOOT2THREE4SEARCH - PATH2THREE: ", path2three)     
        
        return
 
    if (not (queue2three is None) and not(consumer_channel2three is None) and not(publisher_channel2three is None) and (path2three is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2THREE4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2THREE4SEARCH - QUEUE2THREE: ", queue2three)
        print("(STEP 2C/33) OF SHOOT2THREE4SEARCH - CONSUMER_CHANNEL2THREE: ", consumer_channel2three) 
        print("(STEP 2D/33) OF SHOOT2THREE4SEARCH - PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)
        print("(STEP 2E/33) OF SHOOT2THREE4SEARCH - PATH2THREE: ", path2three)     
        return           

    if (not (queue2three is None) and not(consumer_channel2three is None) and not(publisher_channel2three is None) and not(path2three is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2THREE4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2THREE4SEARCH - QUEUE2THREE: ", queue2three)
        # QUEUE2THREE:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2THREE4SEARCH - CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        # CONSUMER_CHANNEL2THREE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2THREE4SEARCH - PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)
        # PUBLISHER_CHANNEL2THREE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2THREE4SEARCH - PATH2THREE: ", path2three)
        # PATH2THREE:  F://temp//yophotos//test2three//
       
        print("(STEP 4A/33) OF SHOOT2THREE4SEARCH - STARTING TO WALK PATH2THREE: ", path2three)   
        # STARTING TO WALK PATH2THREE:  F://temp//yophotos//test2three//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4three = None
        try:
            name2index4three = "index2xxxxxxxx4yo.html"
            path2index4three = path2three + name2index4three
            print("(Step 4B/33) OF SHOOT2THREE4SEARCH - SET PATH2INDEX4THREE TO: ", path2index4three)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2THREE4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4THREE: ", path2index4three)          
            #                    
        fileobject4three = None
        try:
            fileobject4three = open(path2index4three,'w')
            print("(Step 4C/33) OF SHOOT2THREE4SEARCH - OPENED OUTPUT: ", fileobject4three)
            # SHOOT2THREE4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2three//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2THREE4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4three)         
            # 
        try:                
            fileobject4three.write('<html>\n')
            
            fileobject4three.write('<style type="text/css" media="all">\n')
            fileobject4three.write(' @import "http://www.yourthreexi.org/css/halongbay.css";\n')
            fileobject4three.write('</style> \n')
            fileobject4three.write('<p>\n')
            fileobject4three.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4three.write('<br /><a id="000">yourthree<b>&Xi;</b> @Content</a>\n')
            fileobject4three.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4three.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2THREE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4three)         
            #      
        
        
        KB2name4three = {}
        key2name4three = 0
                 
        for file2walk in DirectoryWalker(path2three):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4three [key2name4three] = file2walk
                    print ("KB2NAME4THREE[", key2name4three, "]: ", KB2name4three [key2name4three])
                    # 
                    
                    key2name4three = key2name4three + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2THREE4SEARCH - FAILED UPDATING KB2NAME4THREE WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4three(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4three.write('<br /> \n')
            fileobject4three.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4three.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4three.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4three.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4three.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4three.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4three.write('</p>\n')
            # 
            fileobject4three.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2THREE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4three)         
            #            
        try:    
            fileobject4three.close()
            print("(Step 4C/33) OF SHOOT2THREE4SEARCH - CLOSED OUTPUT: ", fileobject4three)         
            # SHOOT2THREE4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2three//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2THREE4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4three)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2THREE4SEARCH - STARTING TO ANALYSE KB2NAME4THREE: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4THREE:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4three  = {}
        AlphaKB4three['a'] = {}
        AlphaKB4three['b'] = {}
        AlphaKB4three['c'] = {}
        AlphaKB4three['d'] = {}
        AlphaKB4three['e'] = {}
        AlphaKB4three['f'] = {}
        AlphaKB4three['g'] = {}
        AlphaKB4three['h'] = {}
        AlphaKB4three['i'] = {}
        AlphaKB4three['j'] = {}
        AlphaKB4three['k'] = {}
        AlphaKB4three['l'] = {}
        AlphaKB4three['m'] = {}
        AlphaKB4three['n'] = {}
        AlphaKB4three['o'] = {}
        AlphaKB4three['p'] = {}
        AlphaKB4three['q'] = {}
        AlphaKB4three['r'] = {}
        AlphaKB4three['s'] = {}
        AlphaKB4three['t'] = {}
        AlphaKB4three['u'] = {}
        AlphaKB4three['v'] = {}
        AlphaKB4three['w'] = {}
        AlphaKB4three['x'] = {}
        AlphaKB4three['y'] = {}
        AlphaKB4three['z'] = {} 
        keys2AlphaKB4three = AlphaKB4three.keys()
        key2AlphaKB4three  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4three = len(path2three)
        # 
        
        keys2name4three = KB2name4three.keys()
                
        for key2name4three in sorted(keys2name4three):
            # 
            name2optimize4three = KB2name4three[key2name4three]
            # 
            shortcut2level4three = name2optimize4three[len2cut4three:]
            # 
            len2shortcut4three = len(shortcut2level4three)
            if len2shortcut4three == 1:
                try:
                    # LEVEL THREE CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4three in keys2AlphaKB4three:
                        KB2level1[key2level1] = shortcut2level4three
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2THREE4SEARCH ** WARNING - SHORTCUT2LEVEL4THREE: ", shortcut2level4three, " NOT IN KEYS2ALPHAKB4THREE: ", keys2AlphaKB4three)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2THREE4SEARCH *** FAILED - SHORTCUT2LEVEL4THREE: ", shortcut2level4three)      
            else:
                try:
                    
                    string2search4three = '\\'
                    shortcut2level4three = shortcut2level4three[2:]
                    
                    index2level4three=str.find(shortcut2level4three,string2search4three)
                    if index2level4three == -1:
                         
                        KB2level2[key2level2] = shortcut2level4three
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4three = shortcut2level4three[index2level4three+1:]
                        index2level4three=str.find(shortcut2level4three,string2search4three)
                        if index2level4three == -1:
                            KB2level3[key2level3] = shortcut2level4three
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4three = shortcut2level4three[index2level4three+1:]
                            index2level4three=str.find(shortcut2level4three,string2search4three)
                            if index2level4three == -1:
                                KB2level4[key2level4] = shortcut2level4three
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4three = shortcut2level4three[index2level4three+1:]
                                index2level4three=str.find(shortcut2level4three,string2search4three)
                                if index2level4three == -1:
                                    KB2level5[key2level5] = shortcut2level4three
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4three = shortcut2level4three[index2level4three+1:]
                                    index2level4three=str.find(shortcut2level4three,string2search4three)
                                    if index2level4three == -1:
                                        KB2level6[key2level6] = shortcut2level4three
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4three = shortcut2level4three[index2level4three+1:]
                                        index2level4three=str.find(shortcut2level4three,string2search4three)
                                        if index2level4three == -1:
                                            KB2level7[key2level7] = shortcut2level4three
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4three = shortcut2level4three[index2level4three+1:]
                                            index2level4three=str.find(shortcut2level4three,string2search4three)
                                            if index2level4three == -1:
                                                KB2level8[key2level8] = shortcut2level4three
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2THREE4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4THREE: ", shortcut2level4three)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2THREE4SEARCH *** FAILED - SHORTCUT2LEVEL4THREE: ", shortcut2level4three)   
        
        print ("(Step 6A/33) OF SHOOT2THREE4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2THREE4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2THREE4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2THREE4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2THREE4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # threefly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2THREE4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2THREE4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2THREE4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2THREE4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2THREE4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2THREE4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2THREE4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2THREE4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2THREE4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2THREE4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2THREE4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2THREE4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2THREE4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2THREE4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2THREE4SEARCH - COUNT2ACK4THREE; ", count2ack4three)
            # COUNT2ACK4THREE;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2THREE4SEARCH - COUNT2NACK4THREE; ", count2nack4three)
            # COUNT2NACK4THREE;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2THREE4SEARCH - COUNT2FOUND4THREE: ", count2found4three)
            # COUNT2FOUND4THREE:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2THREE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2THREE4SEARCH - FOUND MAX SIZE: ", maxsize2ack4three)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2THREE4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4three)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2THREE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4three == 0:
                meansize2ack4three = 0
                print ("(Step 7G1/33) OF SHOOT2THREE4SEARCH - MEAN SIZE SET: ", meansize2ack4three)
                #  
            else:       
                meansize2ack4three = int(sumsize2ack4three / count2ack4three)
                print ("(Step 7G2/33) OF SHOOT2THREE4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4three, ", WHERE SUMSIZE2ACK4THREE: ", sumsize2ack4three, " COUNT2ACK4THREE: ", count2ack4three)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4THREE:  10944512  COUNT2ACK4THREE:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2THREE4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4three < maxsize2file4three:
                print ("(Step 7H/33) OF SHOOT2THREE4SEARCH - MIN SIZE MET: ", minsize2ack4three)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2THREE4SEARCH ** MIN DEFINED: ", minsize2ack4three, " EQUALS TO MAXSIZE2FILE4THREE: ", maxsize2file4three)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2THREE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2THREE4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2THREE4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2THREE4SEARCH - QUEUE2THREE: ", queue2three)
        print("(STEP 7Z3/33) OF SHOOT2THREE4SEARCH - CONSUMER_CHANNEL2THREE: ", consumer_channel2three) 
        print("(STEP 7Z4/33) OF SHOOT2THREE4SEARCH - PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)
        print("(STEP 7Z5/33) OF SHOOT2THREE4SEARCH - PATH2THREE: ", path2three)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.threexi.com; www.yourthreexi.com; www.yourthreexi.org; www.three2xi.com/; www.three4xi.com/; www.three8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2three4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
